/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclock;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.Stroke;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Rectangle2D;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JPanel;

/**
 *
 * @author Daniels laptop
 */
// public class MyPanel extends JPanel
public class MyPanel extends JPanel implements MouseListener
{
	DBFastClock dbFastClock;
	MyPanelButtonListener buttonsListener;
	
	Rectangle2D buttonSettingsRect;
	
//	String text = "Trafikspelet startar 13.00\nThe traffic game starts at 13:00\nVerkehr Spiel beginnt 13.00";
//	String text = "Det ska skoj o leva, det ska va kul o leva!\nIt should be fun to live, fun to live!\nEs soll Spaß machen zu leben, Spaß zu leben!";
//	String text = "Det ska skoj o leva, det ska va kul o leva!";
	String lastTextMessage = "";

	String dayNames[][] =	{
								{"Måndag","Tisdag","Onsdag","Torsdag","Fredag","Lördag","Söndag"},			// Svenska
								{"Mandag","Tirsdag","Onsdag","Torsdag","Fredag","Lørdag","Søndag"},			// Norska
								{"Mandag","Tirsdag","Onsdag","Torsdag","Fredag","Lørdag","Søndag"},			// Danska
								{"Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"},	// Engelska
								{"Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag","Sonntag"}	// Tyska
							};
	
	boolean bIsClockActive;
	int iClockValueDay;
    int iClockValueHour;
    int iClockValueMin;
    int iClockValueSec;
	double dClockValueSpeed;

	int textPosition = 0;
	long lastTime = System.nanoTime();

	Graphics2D bufferGraphics;
	Image offscreenImage;
	Rectangle bounds;
	
	Graphics bufferGraphicsText;
	Image offscreenImageText;
	Dimension dimText;
	
    Color fgColor = Color.GREEN;
    Color bgColor = Color.BLACK;
	Color textColor = Color.RED;
    
    // Binary coding of 7-segment-display
    //   1
    // 2   3
    //   4
    // 5   6
    //   7
    int iSevenSegmentDisplay[] = {119,36,93,109,46,107,123,39,127,111};
    
//    int iLeftPos[] = {100,200,300,400,500,600,700,800,900,1000};
//    int iLeftPos[] = {100,300,600,800};
    
    int iLeft = 80;
    int iTop = 150;
    double dScale = 1.0;
    
    double dMarginPercentX = 0.1;  // Marginal i %
    double dMarginPercentY = 0.1;  // Marginal i %
    
    int iDigitLeftPos[] = {0,193,426,619};
    int iRadius = 17;
    int iSpace = 1;
    int iColonX = 186+iDigitLeftPos[1]-iRadius-iSpace;
//    int iColonX = iLeft + (int)Math.round( (186+iDigitLeftPos[1]-iRadius-iSpace)*dScale );
    int iColonY[] = {98-iRadius*2-iSpace*2, 98+110-iRadius*2-iSpace*2};
    int iColonRadius = 16;
    int iWidth = 102;
    int iHeight = 116;
    
    int iMinX = iDigitLeftPos[0] - iRadius*2 - iSpace;
    int iMinY = - iRadius*3 - iSpace*2;
    int iMaxX = iDigitLeftPos[3] + iWidth + iRadius*2 + iSpace;
    int iMaxY = iHeight * 2 + iRadius*3 + iSpace*2;
	
	int iSecBarLeft = 0;
	int iSecBarTop = iMaxY + 50;
	int iSecBarWidth = iMaxX / 60;
	int iSecBarHeight = 10;
	private String[] textArray;
	private int textItem;
	private Rectangle2D boundsCurrentText;
	private int iClockValueDayLast;
	private int iClockValueHourLast;
	private int iClockValueMinLast;
	private int iClockValueSecLast;
	private String sTextMessage;
	private boolean bTextMessageVisible;
	private boolean bVirtualSeconds;
	
	private int analogClockBottom;
	

	public MyPanel(DBFastClock dbFastClock)
	{
		super();
		this.dbFastClock = dbFastClock;
		addMouseListener(this);
	}
	
	
    protected boolean isSegmentActive(int iSegment, int iValue)
    {
        return ( (iSevenSegmentDisplay[iValue] & (1 << (iSegment-1))) != 0 );
    }
    
    protected int scaleDistX(double iX)
    {
        return (int)Math.round( iX * dScale );
    }
    
    protected int scaleDistY(int iY)
    {
        return (int)Math.round( iY * dScale );
    }
    
    protected int scaleX(int iX)
    {
        return iLeft + scaleDistX(iX);
    }
    
    protected int scaleY(int iY)
    {
        return iTop + scaleDistY(iY);
    }
    
    protected void drawSegment(Graphics g, int x1, int y1, int x2, int y2)
    {
        Polygon p = new Polygon();
        
        if (y1 == y2)
        {
            p.addPoint(scaleX(x1-iRadius),scaleY(y1));
            p.addPoint(scaleX(x1),scaleY(y1-iRadius));
            p.addPoint(scaleX(x2),scaleY(y2-iRadius));
            p.addPoint(scaleX(x2+iRadius),scaleY(y2));
            p.addPoint(scaleX(x2),scaleY(y2+iRadius));
            p.addPoint(scaleX(x1),scaleY(y1+iRadius));
            p.addPoint(scaleX(x1-iRadius),scaleY(y1));
        }
        else
        {
            p.addPoint(scaleX(x1),scaleY(y1-iRadius));
            p.addPoint(scaleX(x1+iRadius),scaleY(y1));
            p.addPoint(scaleX(x2+iRadius),scaleY(y2));
            p.addPoint(scaleX(x2),scaleY(y2+iRadius));
            p.addPoint(scaleX(x2-iRadius),scaleY(y2));
            p.addPoint(scaleX(x1-iRadius),scaleY(y1));
            p.addPoint(scaleX(x1),scaleY(y1-iRadius));
        }
        
        g.fillPolygon(p);
//        g.drawLine(x1,y1,x2,y2);
    }
    
    protected void drawDigit(Graphics g, int iNum, int iValue)
    {
        int iLeftPos = iDigitLeftPos[iNum];
//        int iTop = 100;
//        int iWidth = 50;
//        int iHeight = 100;
        
        g.fillOval(scaleX(iColonX-iColonRadius), scaleY(iColonY[0]-iColonRadius), scaleDistX(iColonRadius*2), scaleDistY(iColonRadius*2));
        g.fillOval(scaleX(iColonX-iColonRadius), scaleY(iColonY[1]-iColonRadius), scaleDistX(iColonRadius*2), scaleDistY(iColonRadius*2));

        if (iValue == -1)
        {
            // Draw segment 4
            drawSegment(g, iLeftPos, iHeight, iLeftPos + iWidth, iHeight);
        }
        else
        {
            if (isSegmentActive(1, iValue)) {
                drawSegment(g, iLeftPos, -iRadius*2-iSpace*2, iLeftPos + iWidth, -iRadius*2-iSpace*2);
            }
            if (isSegmentActive(2, iValue)) {
                drawSegment(g, iLeftPos-iRadius-iSpace, -iRadius-iSpace, iLeftPos-iRadius-iSpace,  + iHeight-iRadius-iSpace);
            }
            if (isSegmentActive(3, iValue)) {
                drawSegment(g, iLeftPos + iWidth+iRadius+iSpace, -iRadius-iSpace, iLeftPos + iWidth+iRadius+iSpace,  + iHeight-iRadius-iSpace);
            }
            if (isSegmentActive(4, iValue)) {
                drawSegment(g, iLeftPos, iHeight, iLeftPos + iWidth, iHeight);
            }
            if (isSegmentActive(5, iValue)) {
                drawSegment(g, iLeftPos-iRadius-iSpace,  + iHeight+iRadius+iSpace, iLeftPos-iRadius-iSpace,  + iHeight * 2+iRadius+iSpace);
            }
            if (isSegmentActive(6, iValue)) {
                drawSegment(g, iLeftPos + iWidth+iRadius+iSpace,  + iHeight+iRadius+iSpace, iLeftPos + iWidth+iRadius+iSpace,  + iHeight * 2+iRadius+iSpace);
            }
            if (isSegmentActive(7, iValue)) {
                drawSegment(g, iLeftPos, iHeight * 2+iRadius*2+iSpace*2, iLeftPos + iWidth, iHeight * 2+iRadius*2+iSpace*2);
            }
        }
        
//        g.setColor(Color.blue);
//        g.drawRect(scaleX(iMinX), scaleY(iMinY), scaleDistX(iMaxX-iMinX), scaleDistY(iMaxY-iMinY));
//        g.setColor(Color.green);
    }
	
	protected void drawSecondBar(Graphics g)
	{
		int iSecTop = 0;
		int iSecHeight = 0;
		
		if (dbFastClock.clockStyle == DBFastClock.CLOCK_STYLE_DIGITAL)
		{
			iSecHeight = 2;
//			iSecHeight = scaleDistY(iSecBarHeight);
			iSecTop = scaleY(iSecBarTop);
		}
		else if (dbFastClock.clockStyle == DBFastClock.CLOCK_STYLE_ANALOG)
		{
			int iSecBottom = analogClockBottom;
			
			iSecHeight = 1;
			iSecTop = iSecBottom - iSecHeight;
		}
		
        g.setColor(bgColor);
		g.fillRect(scaleX(iSecBarLeft), iSecTop, scaleDistX(iSecBarWidth*59), iSecHeight);
        g.setColor(fgColor);
//		g.fillRect(scaleX(iSecBarLeft), scaleY(iSecBarTop), scaleDistX(iSecBarWidth*iClockValueSec), scaleDistY(iSecBarHeight));
		
		for (int i=0; i <= iClockValueSec; i++)
			g.fillRect(scaleX(iSecBarLeft+iSecBarWidth*i), iSecTop, scaleDistX(iSecBarWidth*0.5), iSecHeight);
	}
    
	
	protected void drawDigitalClock(Graphics g)
	{
		if (iClockValueHour == -1)
		{
			drawDigit(bufferGraphics, 0, -1);
			drawDigit(bufferGraphics, 1, -1);
			drawDigit(bufferGraphics, 2, -1);
			drawDigit(bufferGraphics, 3, -1);
		}
		else
		{
			drawDigit(bufferGraphics, 0, iClockValueHour / 10);
			drawDigit(bufferGraphics, 1, iClockValueHour % 10);
			drawDigit(bufferGraphics, 2, iClockValueMin / 10);
			drawDigit(bufferGraphics, 3, iClockValueMin % 10);
		}
	}
	
	
	protected void drawAnalogClock(Graphics g)
	{
		analogClockBottom = bounds.height-20;
		
		if (bTextMessageVisible && (offscreenImageText != null))
			analogClockBottom = bounds.height-dimText.height;
		
		Point center = new Point(bounds.width / 2, analogClockBottom / 2);

		Double clockRingRadius = Math.min(center.x, center.y) * 0.98 * 0.9;
		Double hourLinesOuterRadius = Math.min(center.x, center.y) * 0.95 * 0.9;
		Double hourLinesInnerRadius = Math.min(center.x, center.y) * 0.87 * 0.9;
		Double minLinesInnerRadius = Math.min(center.x, center.y) * 0.92 * 0.9;
		Double hourRadius = Math.min(center.x, center.y) * 0.6 * 0.9;
		Double minRadius = Math.min(center.x, center.y) * 0.85 * 0.9;
		Double innerRadius = Math.min(center.x, center.y) * 0.1 * 0.9;

		Stroke clockRingStroke = new BasicStroke((float) (clockRingRadius / 40));
		Stroke hourLinesStroke = new BasicStroke((float) (clockRingRadius / 20), BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER);
		Stroke minLinesStroke = new BasicStroke((float) (clockRingRadius / 60), BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER);
		Stroke hourStroke = new BasicStroke((float) (clockRingRadius / 10), BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER);
		Stroke minStroke = new BasicStroke((float) (clockRingRadius / 20), BasicStroke.CAP_ROUND, BasicStroke.JOIN_MITER);

		bufferGraphics.setStroke(clockRingStroke);
		bufferGraphics.drawOval(center.x - (int) Math.round(clockRingRadius),
								center.y - (int) Math.round(clockRingRadius),
								(int) (2 * Math.round(clockRingRadius)),
								(int) (2 * Math.round(clockRingRadius)));

//			bufferGraphics.drawRect(0, 0, bounds.width-1, bounds.height-1);

		bufferGraphics.setStroke(minLinesStroke);

		for (int i = 1; i <= 60; i++)
		{
			bufferGraphics.drawLine(center.x + (int) Math.round(minLinesInnerRadius * Math.cos((i - 15) * 2 * Math.PI / 60)),
									center.y + (int) Math.round(minLinesInnerRadius * Math.sin((i - 15) * 2 * Math.PI / 60)),
									center.x + (int) Math.round(hourLinesOuterRadius * Math.cos((i - 15) * 2 * Math.PI / 60)),
									center.y + (int) Math.round(hourLinesOuterRadius * Math.sin((i - 15) * 2 * Math.PI / 60)));
		}

		bufferGraphics.setStroke(hourLinesStroke);

		for (int i = 1; i <= 12; i++)
		{
			bufferGraphics.drawLine(center.x + (int) Math.round(hourLinesInnerRadius * Math.cos((i - 3) * 2 * Math.PI / 12)),
									center.y + (int) Math.round(hourLinesInnerRadius * Math.sin((i - 3) * 2 * Math.PI / 12)),
									center.x + (int) Math.round(hourLinesOuterRadius * Math.cos((i - 3) * 2 * Math.PI / 12)),
									center.y + (int) Math.round(hourLinesOuterRadius * Math.sin((i - 3) * 2 * Math.PI / 12)));
		}

		bufferGraphics.setStroke(hourStroke);
		bufferGraphics.drawLine(center.x + (int) Math.round(innerRadius * Math.cos(((iClockValueHour + 3) + (iClockValueMin / 15) / 4.0) * 2 * Math.PI / 12)),
								center.y + (int) Math.round(innerRadius * Math.sin(((iClockValueHour + 3) + (iClockValueMin / 15) / 4.0) * 2 * Math.PI / 12)),
								center.x + (int) Math.round(hourRadius * Math.cos(((iClockValueHour - 3) + (iClockValueMin / 15) / 4.0) * 2 * Math.PI / 12)),
								center.y + (int) Math.round(hourRadius * Math.sin(((iClockValueHour - 3) + (iClockValueMin / 15) / 4.0) * 2 * Math.PI / 12)));

		bufferGraphics.setStroke(minStroke);
		bufferGraphics.drawLine(center.x + (int) Math.round(innerRadius * Math.cos((iClockValueMin + 15) * 2 * Math.PI / 60)),
								center.y + (int) Math.round(innerRadius * Math.sin((iClockValueMin + 15) * 2 * Math.PI / 60)),
								center.x + (int) Math.round(minRadius * Math.cos((iClockValueMin - 15) * 2 * Math.PI / 60)),
								center.y + (int) Math.round(minRadius * Math.sin((iClockValueMin - 15) * 2 * Math.PI / 60)));
	}
	
	
    protected synchronized void paintComponent_ThreadSafe(Graphics g, boolean bPaintAll)
	{

		// Then the program exits g may be null
		if (g == null)
		{
//			System.out.println("g == null");
			return;
		}
		
		
		if (bVirtualSeconds)
		{
			long time = System.nanoTime();
			
			if	(	(iClockValueDay != iClockValueDayLast) ||
					(iClockValueHour != iClockValueHourLast) ||
					(iClockValueMin != iClockValueMinLast)
				)
			{
				lastTime = time;
			}
			
			iClockValueSec = (int) Math.round((time - lastTime) * dClockValueSpeed / 1000 / 1000 / 1000);

			if (iClockValueSec > 59)
				iClockValueSec = 0;
		}
		
		
		if (bTextMessageVisible && (sTextMessage != null))
		{
			if (!sTextMessage.equals(lastTextMessage))
			{
				bufferGraphicsText = null;
				textArray = sTextMessage.split("\n");
				lastTextMessage = sTextMessage;
			}
		}
		else
		{
			if (lastTextMessage != null)
			{
				bufferGraphicsText = null;
				textArray = new String[0];
				lastTextMessage = sTextMessage;
			}
		}
		
//		System.out.println("bufferGraphicsText!=null: "+(bufferGraphicsText!=null)+", bTextMessageVisible: "+bTextMessageVisible+", sTextMessage: "+sTextMessage);
//		if (bufferGraphicsText == null)
		if ( (bufferGraphicsText == null) && bTextMessageVisible && (sTextMessage != null) )
		{
			System.out.println("AAA");
//				Font font = new Font("Arial", Font.PLAIN, 150);
			Font font = new Font("Arial", Font.PLAIN, bounds.height / 6);
			FontMetrics metrics = new FontMetrics(font)
			{
			};

			Rectangle2D boundsText;
			double maxWidth = 0;
			double maxHeight = 0;
			for (int i = 0; i < textArray.length; i++)
			{
				boundsText = metrics.getStringBounds(textArray[i], null);
				if (boundsText.getWidth() > maxWidth)
				{
					maxWidth = boundsText.getWidth();
				}
				if (boundsText.getHeight() > maxHeight)
				{
					maxHeight = boundsText.getHeight();
				}
			}

			if (maxWidth != 0)
			{
				boundsText = new Rectangle(0, 0, (int) maxWidth, (int) maxHeight)
				{
				};

				dimText = new Dimension((int) Math.round(boundsText.getWidth()) + 20, (int) Math.round(boundsText.getHeight()) + 20);
				offscreenImageText = createImage(dimText.width, dimText.height);
				bufferGraphicsText = offscreenImageText.getGraphics();
				textPosition = Integer.MAX_VALUE;
				textItem = -1;
				boundsCurrentText = new Rectangle(0, 0, 0, 0);
			}
			else
				offscreenImageText = null;
		}
		
		
		if ((offscreenImageText != null) && (textPosition > boundsCurrentText.getWidth()))
		{
			textItem++;
			if (textItem >= textArray.length)
			{
				textItem = 0;
			}
			
			textPosition = -bounds.width;
			
//			Font font = new Font("Arial", Font.PLAIN, 150);
			Font font = new Font("Arial", Font.PLAIN, bounds.height / 6);
			FontMetrics metrics = new FontMetrics(font) { };
			boundsCurrentText = metrics.getStringBounds(textArray[textItem], null);
			bufferGraphicsText.setColor(bgColor);
			bufferGraphicsText.fillRect(0, 0, dimText.width, dimText.height);
			bufferGraphicsText.setColor(textColor);
			bufferGraphicsText.setFont(font);
			bufferGraphicsText.drawString(textArray[textItem], 0, metrics.getAscent());
		}
		
		
		if	(	(iClockValueDay != iClockValueDayLast) ||
				(iClockValueHour != iClockValueHourLast) ||
				(iClockValueMin != iClockValueMinLast) ||
				(iClockValueSec != iClockValueSecLast) ||
				bPaintAll
			)
		{
			iClockValueDayLast = iClockValueDay;
			iClockValueHourLast = iClockValueHour;
			iClockValueMinLast = iClockValueMin;
			iClockValueSecLast = iClockValueSec;
			

			Rectangle newBounds = this.getBounds();
			if ((bounds == null) || (!bounds.equals(newBounds)))
			{
				// Force creation of new double buffer
				bufferGraphics = null;
				bounds = newBounds;
			}

			// Init double buffering
			if (bufferGraphics == null)
			{
				offscreenImage = createImage(bounds.width, bounds.height);
				bufferGraphics = (Graphics2D) offscreenImage.getGraphics();
			}


			bufferGraphics.setColor(bgColor);
			bufferGraphics.fillRect(bounds.x, bounds.y, bounds.width, bounds.height);

			bufferGraphics.setColor(fgColor);

			double dAdditionalScaleFactor = 1.0;

			if (bTextMessageVisible)
				dAdditionalScaleFactor = 0.8;
			else
				dAdditionalScaleFactor = 1.0;

			double dMarginX = bounds.width * dMarginPercentX;
			double dMarginY = bounds.height * dMarginPercentY;

			double dScaleX = (bounds.width - 2 * dMarginX) / (iMaxX - iMinX) * dAdditionalScaleFactor;
			double dScaleY = (bounds.height - 2 * dMarginY) / (iMaxY - iMinY) * dAdditionalScaleFactor;

			if (dScaleX > dScaleY)
			{
				dScale = dScaleY;
			}
			else
			{
				dScale = dScaleX;
			}

			iLeft = (int) Math.round(-iMinX * dScale + dMarginX);
			iTop = (int) Math.round(-iMinY * dScale + dMarginY);
			
			// Show digital clock if we have no time
			if ( (dbFastClock.clockStyle == DBFastClock.CLOCK_STYLE_DIGITAL) || (iClockValueHour == -1) )
				drawDigitalClock(g);
			else if (dbFastClock.clockStyle == DBFastClock.CLOCK_STYLE_ANALOG)
				drawAnalogClock(g);
			
			drawSecondBar(bufferGraphics);


			Font font = new Font("Verdana", Font.BOLD, 15);
			FontMetrics metrics = new FontMetrics(font) { };

			String settingsText = dbFastClock.getLocalizedName("label_","settings");
//			String settingsText = "Inställningar";

			Rectangle2D boundsText_Settings = metrics.getStringBounds(settingsText, null);

			int buttonX = 5;
			int buttonY = 10;
			int buttonPaddingWidth = 6;
			int buttonPaddingHeight = 0;
			int buttonAdditionalHeight = 4;
//			int buttonSpacing = 10;

			buttonSettingsRect = new Rectangle(buttonX,
											   buttonY,
											   (int) boundsText_Settings.getWidth() + buttonPaddingWidth * 2,
											   (int) boundsText_Settings.getHeight() + buttonPaddingHeight * 2 + buttonAdditionalHeight);

			bufferGraphics.setFont(font);
			bufferGraphics.setColor(Color.LIGHT_GRAY);
			bufferGraphics.fillRoundRect((int) buttonSettingsRect.getX(),
										 (int) buttonSettingsRect.getY(),
										 (int) buttonSettingsRect.getWidth(),
										 (int) buttonSettingsRect.getHeight(),
										 12,
										 20);
			bufferGraphics.setColor(Color.BLACK);
			bufferGraphics.drawString(settingsText,
									  (int) buttonSettingsRect.getX() + buttonPaddingWidth,
									  (int) buttonSettingsRect.getY() + buttonPaddingHeight + metrics.getAscent());

//			if (bTextMessageVisible)
			if ( bTextMessageVisible && (offscreenImageText != null) )
				bufferGraphics.drawImage(offscreenImageText,-textPosition,bounds.height-dimText.height,this);
			
			g.drawImage(offscreenImage,bounds.x,bounds.y,this);
		}
		else
		{
			if (bTextMessageVisible && (offscreenImageText != null))
				g.drawImage(offscreenImageText,-textPosition,bounds.height-dimText.height,this);
		}
		
		
		textPosition += 1;
    }

	
	@Override
    protected void paintComponent(Graphics g)
	{
		paintComponent_ThreadSafe(g,true);
	}
	
	
    void SetClock(int iClockDay, int iClockHour, int iClockMin, int iClockSec, double dClockSpeed)
	{
        iClockValueHour = iClockHour;
        iClockValueMin = iClockMin;
        iClockValueSec = iClockSec;
        dClockValueSpeed = dClockSpeed;
		
		bVirtualSeconds = (iClockSec == -1);
    }
    
	
	void SetText(boolean bTextMessageVisible, String sTextMessage)
	{
		this.bTextMessageVisible = bTextMessageVisible;
		this.sTextMessage = sTextMessage;
	}
	
	
	void SetColor(Color fColor, Color bColor, Color txtColor) {
		fgColor = fColor;
		bgColor = bColor;
		textColor = txtColor;
		
		this.setBackground(bgColor);
	}
	
	
	public void paintNow()
	{
		paintComponent_ThreadSafe(getGraphics(),false);
	}
	
	
	@Override
	public void mouseClicked(MouseEvent e)
	{
		System.out.println("MouseClicked()");
		if ( (e.getButton() == MouseEvent.BUTTON1) && (buttonSettingsRect != null) && (buttonsListener != null) )
		{
			try
			{
				if (buttonSettingsRect.contains(e.getPoint()))
					buttonsListener.ButtonSettingsPressed();
			}
			catch (Exception ex)
			{
				Logger.getLogger(MyPanel.class.getName()).log(Level.SEVERE, null, ex);
			}
		}
	}

	@Override
	public void mousePressed(MouseEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}

	@Override
	public void mouseReleased(MouseEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}

	@Override
	public void mouseEntered(MouseEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}

	@Override
	public void mouseExited(MouseEvent e)
	{
//		throw new UnsupportedOperationException("Not supported yet.");
	}
    
	
	public void componentResized()
	{
		// Force update of text size
		bufferGraphicsText = null;
	}
	
}
