/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dbfastclock;

import java.io.BufferedWriter;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

/**
 *
 * @author Daniels laptop
 */
public class MySignal
{
	public static final int CLOCK_TYPE__FAST_CLOCK = 0;
	public static final int CLOCK_TYPE__REAL_CLOCK = 1;
	
	public static final int WEEKDAY_NONE = 0;
	public static final int WEEKDAY_MONDAY = 1;
	public static final int WEEKDAY_TUESDAY = 2;
	public static final int WEEKDAY_WEDNESDAY = 3;
	public static final int WEEKDAY_THURSDAY = 4;
	public static final int WEEKDAY_FRIDAY = 5;
	public static final int WEEKDAY_SATURDAY = 6;
	public static final int WEEKDAY_SUNDAY = 7;
	
	public BufferedWriter debug;
	
	private final ClockCollection clockCollection = new ClockCollection();
	
    private boolean bUseMulticast = false;
    private String sMulticastAddress = "127.0.0.1";
    private int iMulticastPort = -1;    // -1 is invalid TCP port number and the thread will not try connect in this case
    private String sClientIPaddress = "127.0.0.1";
    private int iClientTCPport = -1;    // -1 is invalid TCP port number and the thread will not try connect in this case
    private String sNameOfClock = "";
	private int iClockType = 1;		// 0 = Snabbklocka, 1 = Datortid
	private boolean bClockIsActive = false;		// 1 = Klockan går, 0 = Klockan är pausad
    private int iClockDay = -1;
    private int iClockHour = -1;
    private int iClockMin = -1;
	private int iClockSec = -1;
	private double dClockSpeed = -1;
	private boolean bTextMessageVisible;
	private String sTextMessage;
	private boolean tryToAutodetectedServerIPAddress;
	private String autodetectedServerIPAddress;
	
	
    public synchronized void setMulticastAddressAndPort(String sMulticastAddress, int iMulticastPort)
	{
		this.sMulticastAddress = sMulticastAddress;
		this.iMulticastPort = iMulticastPort;
    }

    public synchronized void setIPaddressAndPort(String iTheClientIPaddress, int iTheClientTCPport)
	{
        sClientIPaddress = iTheClientIPaddress;
        iClientTCPport = iTheClientTCPport;
    }

	public synchronized void setUseMulticast(boolean useMulticast)
	{
		this.bUseMulticast = useMulticast;
	}
	
    public synchronized boolean getUseMulticast()
	{
        return bUseMulticast;
    }
	
    public synchronized String getMulticastAddress()
	{
        return sMulticastAddress;
    }
    
    public synchronized int getMulticastPort()
	{
        return iMulticastPort;
    }
	
    public synchronized String getClientIPaddress()
	{
        return sClientIPaddress;
    }
    
    public synchronized int getClientTCPport()
	{
        return iClientTCPport;
    }
	
	public synchronized void setTryToAutodetectedServerIPAddress(boolean tryToAutodetectedServerIPAddress)
	{
		this.tryToAutodetectedServerIPAddress = tryToAutodetectedServerIPAddress;
	}
	
	public synchronized boolean getTryToAutodetectedServerIPAddress()
	{
		return tryToAutodetectedServerIPAddress;
	}
	
    public synchronized String getNameOfClock()
	{
        return sNameOfClock;
    }
	
    public synchronized Iterator<String> getClockSetIterator()
	{
        return clockCollection.iterator();
    }
	
    public synchronized void addClock(String clock)
	{
		clockCollection.addClock(clock);
    }
	
    public void setNameOfClock(String sNameOfClock)
	{
        this.sNameOfClock = sNameOfClock;
    }
    
	public synchronized String getAutodetectedServerIPAddress()
	{
		return autodetectedServerIPAddress;
	}
    
	public synchronized void setAutodetectedServerIPAddress(String autodetectedServerIPAddress)
	{
		this.autodetectedServerIPAddress = autodetectedServerIPAddress;
	}
    
    public synchronized void setClock(	int iType,
										boolean bIsActive,
										int iDay,
										int iHour,
										int iMin,
										int iSec,
										double dSpeed)
	{
        iClockType = iType;
        bClockIsActive = bIsActive;
        iClockDay = iDay;
        iClockHour = iHour;
        iClockMin = iMin;
        iClockSec = iSec;
        dClockSpeed = dSpeed;
    }

	
	void SetText(boolean bTextMessageVisible, String sTextMessage)
	{
		this.bTextMessageVisible = bTextMessageVisible;
		this.sTextMessage = sTextMessage;
	}
	
	
    public synchronized int getClockType()
	{
        return iClockType;
    }
    
    public synchronized boolean getClockIsActive()
	{
        return bClockIsActive;
    }
    
    public synchronized int getClockDay()
	{
        return iClockDay;
    }
    
    public synchronized int getClockHour()
	{
        return iClockHour;
    }
    
    public synchronized int getClockMin()
	{
        return iClockMin;
    }
    
    public synchronized int getClockSec()
	{
        return iClockSec;
    }
    
    public synchronized double getClockSpeed()
	{
        return dClockSpeed;
    }
    
    public synchronized boolean getTextVisible()
	{
        return bTextMessageVisible;
    }
    
    public synchronized String getText()
	{
        return (bTextMessageVisible ? sTextMessage : "");
    }
    
	
	public static String getYesNoString(boolean bValue)
	{
		return (bValue ? "yes" : "no");
	}
	
	
	public static String getClockTypeString(int iClockType)
	{
		switch (iClockType)
		{
			case CLOCK_TYPE__REAL_CLOCK: return "realclock";
			case CLOCK_TYPE__FAST_CLOCK: return "fastclock";
			default: return "error_wrong_value";
		}
	}
	
	
	public static String getDayString(int iDay)
	{
		switch (iDay)
		{
			case WEEKDAY_NONE: return "none";
			case WEEKDAY_MONDAY: return "monday";
			case WEEKDAY_TUESDAY: return "tuesday";
			case WEEKDAY_WEDNESDAY: return "wednesday";
			case WEEKDAY_THURSDAY: return "thursday";
			case WEEKDAY_FRIDAY: return "friday";
			case WEEKDAY_SATURDAY: return "saturday";
			case WEEKDAY_SUNDAY: return "sunday";
			default: return "error_wrong_value";
		}
	}
	
	
	
	private class ClockCollection
	{
		private final Set<String> clockSet = new HashSet<>();
		
		public void addClock(String clock)
		{
			if (! clockSet.contains(clock))
				clockSet.add(clock);
		}
		
		public Iterator<String> iterator()
		{
			// We don't want to expose clockSet so we create a new collection and return an iterator for that collection
			
			Set<String> set = new HashSet<>(clockSet);
			
			return set.iterator();
		}
	}
	
}
