/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package dbfastclock;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniel Bergqvist
 */
public class UDP_Listener implements Runnable
{
	
	MySignal mySignal;
	
	
	public UDP_Listener(MySignal mySignal)
	{
		this.mySignal = mySignal;
	}
	
	
	@Override
	public void run()
	{
		DatagramSocket socket = null;
		DatagramPacket packet;

        while (true)
		{
			try
			{
				socket = new DatagramSocket(mySignal.getClientTCPport());
			}
			catch (SocketException ex)
			{
				System.out.println("Problem creating socket on port: " + mySignal.getClientTCPport());
			}

			int maxLength = 1000;
			
			packet = new DatagramPacket(new byte[maxLength], maxLength);

			while (true)
			{
				if (mySignal.getTryToAutodetectedServerIPAddress() && (socket != null))
				{
//					System.out.println("Try to autodetect IP address");
					
					try
					{
						socket.receive(packet);
						
						byte data[] = packet.getData();
						
						// Convert byte array to string, but only that number of bytes that has been received
						String message = new String(data).substring(0, packet.getLength());
						
//						System.out.println(String.format("Message: %s, Length: %d, data.length",message,packet.getLength(), data.length));
						
						String lines[] = message.split("\r\n");
						
						if ((lines.length > 0) && (lines[0].toUpperCase().equals("FASTCLOCK")))
						{
							for (int i=1; i < lines.length; i++)
							{
								if (lines[i].length() > 0)
								{
									String parts[] = lines[i].split("=");
									
									switch (parts[0].toUpperCase())
									{
										case "VERSION":
//											System.out.println("Server version: "+parts[1]);
											break;
											
										case "IP-ADDRESS":
//											System.out.println("IP address: "+parts[1]);
											mySignal.setAutodetectedServerIPAddress(parts[1]);
											break;
											
										default:
											System.out.println("Unknown parameter: '"+parts[0]+"'");
									}
								}
							}
						}
						
//						System.out.println("Received UDP packet from: " + packet.getAddress().getHostAddress() + ":" + packet.getPort());
					}
					catch (IOException ie)
					{
						ie.printStackTrace();
					}
				}
				else
				{
					try
					{
						Thread.sleep(100);
					}
					catch (InterruptedException ex)
					{
						// Do nothing
					}
				}
			}
		}
	}
	
}
